"use strict";

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('react'), require('antd')) : typeof define === 'function' && define.amd ? define(['react', 'antd'], factory) : (global = global || self, global.tasks = factory(global.React, global.antd));
})(void 0, function (React, antd) {
  'use strict';

  var React__default = 'default' in React ? React['default'] : React;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(source, true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(source).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
  }

  function styleInject(css, ref) {
    if (ref === void 0) ref = {};
    var insertAt = ref.insertAt;

    if (!css || typeof document === 'undefined') {
      return;
    }

    var head = document.head || document.getElementsByTagName('head')[0];
    var style = document.createElement('style');
    style.type = 'text/css';

    if (insertAt === 'top') {
      if (head.firstChild) {
        head.insertBefore(style, head.firstChild);
      } else {
        head.appendChild(style);
      }
    } else {
      head.appendChild(style);
    }

    if (style.styleSheet) {
      style.styleSheet.cssText = css;
    } else {
      style.appendChild(document.createTextNode(css));
    }
  }

  var css = ".ui-module_container__257hB {\n  width: 100%;\n  padding: 0 20px;\n}\n.ui-module_actions__glWsk {\n  margin: 0 auto 24px;\n}\n.ui-module_output__og6ar {\n  display: inline-block;\n}\n.ui-module_output__og6ar:hover {\n  color: #fff;\n}\n.ui-module_row__3ZzEB {\n  height: 64px;\n  line-height: 64px;\n}\n.ui-module_normal__caA2b {\n  overflow: hidden;\n}\n.ui-module_buttonGroup__3CJiG > button {\n  margin-right: 8px;\n}\n.ui-module_formatGroup__2hCII {\n  text-align: right;\n}\n.ui-module_logContainer__3JQQL {\n  margin-top: 12px;\n  height: 90%;\n  overflow: hidden;\n}\n.ui-module_title__14x9F {\n  font-size: 16px;\n  color: rgba(255, 255, 255, 0.85);\n  line-height: 24px;\n  margin-top: 16px;\n  margin-bottom: 8px;\n}\n";
  var styles = {
    "container": "ui-module_container__257hB",
    "actions": "ui-module_actions__glWsk",
    "output": "ui-module_output__og6ar",
    "row": "ui-module_row__3ZzEB",
    "normal": "ui-module_normal__caA2b",
    "buttonGroup": "ui-module_buttonGroup__3CJiG",
    "formatGroup": "ui-module_formatGroup__2hCII",
    "logContainer": "ui-module_logContainer__3JQQL",
    "title": "ui-module_title__14x9F"
  };
  styleInject(css);
  var TaskState;

  (function (TaskState) {
    TaskState["INIT"] = "INIT";
    TaskState["ING"] = "ING";
    TaskState["SUCCESS"] = "SUCCESS";
    TaskState["FAIL"] = "FAIL";
  })(TaskState || (TaskState = {}));

  var TaskType;

  (function (TaskType) {
    TaskType["BUILD"] = "BUILD";
    TaskType["DEV"] = "DEV";
    TaskType["TEST"] = "TEST";
    TaskType["LINT"] = "LINT";
    TaskType["INSTALL"] = "INSTALL";
  })(TaskType || (TaskType = {}));

  var TaskEventType;

  (function (TaskEventType) {
    TaskEventType["STD_OUT_DATA"] = "STD_OUT_DATA";
    TaskEventType["STD_ERR_DATA"] = "STD_ERR_DATA";
    TaskEventType["STATE_EVENT"] = "STATE_EVENT";
  })(TaskEventType || (TaskEventType = {}));

  var LogType;

  (function (LogType) {
    LogType["STD_OUT"] = "STD_OUT";
    LogType["STD_ERR"] = "STD_ERR";
  })(LogType || (LogType = {}));

  var TriggerState;

  (function (TriggerState) {
    TriggerState["SUCCESS"] = "SUCCESS";
    TriggerState["FAIL"] = "FAIL";
  })(TriggerState || (TriggerState = {}));

  var runTask =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(taskType, env) {
      var result, errMsg, triggerState;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              result = {};
              errMsg = '';
              triggerState = TriggerState.SUCCESS;
              _context.prev = 3;
              _context.next = 6;
              return callRemote({
                type: 'tasks/run',
                payload: {
                  type: taskType,
                  env: env ? env : {}
                }
              });

            case 6:
              result = _context.sent;
              _context.next = 13;
              break;

            case 9:
              _context.prev = 9;
              _context.t0 = _context["catch"](3);
              errMsg = _context.t0.message;
              triggerState = TriggerState.FAIL;

            case 13:
              return _context.abrupt("return", {
                triggerState: triggerState,
                result: result,
                errMsg: errMsg
              });

            case 14:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[3, 9]]);
    }));

    return function runTask(_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();

  var cancelTask =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(taskType) {
      var result, errMsg, triggerState;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              result = {};
              errMsg = '';
              triggerState = TriggerState.SUCCESS;
              _context2.prev = 3;
              _context2.next = 6;
              return callRemote({
                type: 'tasks/cancel',
                payload: {
                  type: taskType
                }
              });

            case 6:
              result = _context2.sent;
              _context2.next = 13;
              break;

            case 9:
              _context2.prev = 9;
              _context2.t0 = _context2["catch"](3);
              errMsg = _context2.t0.stack;
              triggerState = TriggerState.FAIL;

            case 13:
              return _context2.abrupt("return", {
                triggerState: triggerState,
                result: result,
                errMsg: errMsg
              });

            case 14:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[3, 9]]);
    }));

    return function cancelTask(_x3) {
      return _ref2.apply(this, arguments);
    };
  }();

  var getTaskDetail =
  /*#__PURE__*/
  function () {
    var _ref3 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3(taskType) {
      var result, errMsg, triggerState;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              result = {};
              errMsg = '';
              triggerState = TriggerState.SUCCESS;
              _context3.prev = 3;
              _context3.next = 6;
              return callRemote({
                type: 'tasks/detail',
                payload: {
                  type: taskType
                }
              });

            case 6:
              result = _context3.sent;
              _context3.next = 13;
              break;

            case 9:
              _context3.prev = 9;
              _context3.t0 = _context3["catch"](3);
              errMsg = _context3.t0.message;
              triggerState = TriggerState.FAIL;

            case 13:
              return _context3.abrupt("return", {
                triggerState: triggerState,
                result: result,
                errMsg: errMsg
              });

            case 14:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[3, 9]]);
    }));

    return function getTaskDetail(_x4) {
      return _ref3.apply(this, arguments);
    };
  }();

  var exec =
  /*#__PURE__*/
  function () {
    var _ref4 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4(taskType, env) {
      var _ref5, runTaskTriggerState, errMsg;

      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return runTask(taskType, env);

            case 2:
              _ref5 = _context4.sent;
              runTaskTriggerState = _ref5.triggerState;
              errMsg = _ref5.errMsg;

              if (!(runTaskTriggerState === TriggerState.FAIL)) {
                _context4.next = 7;
                break;
              }

              return _context4.abrupt("return", {
                triggerState: TriggerState.FAIL,
                errMsg: errMsg,
                result: null
              });

            case 7:
              return _context4.abrupt("return", {
                triggerState: TriggerState.SUCCESS,
                errMsg: ''
              });

            case 8:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function exec(_x5, _x6) {
      return _ref4.apply(this, arguments);
    };
  }();

  var cancel =
  /*#__PURE__*/
  function () {
    var _ref6 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee5(taskType) {
      var _ref7, runTaskTriggerState, errMsg;

      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.next = 2;
              return cancelTask(taskType);

            case 2:
              _ref7 = _context5.sent;
              runTaskTriggerState = _ref7.triggerState;
              errMsg = _ref7.errMsg;

              if (!(runTaskTriggerState === TriggerState.FAIL)) {
                _context5.next = 7;
                break;
              }

              return _context5.abrupt("return", {
                triggerState: TriggerState.FAIL,
                errMsg: errMsg,
                result: null
              });

            case 7:
              return _context5.abrupt("return", {
                triggerState: TriggerState.SUCCESS,
                errMsg: ''
              });

            case 8:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));

    return function cancel(_x7) {
      return _ref6.apply(this, arguments);
    };
  }();

  var clearLog =
  /*#__PURE__*/
  function () {
    var _ref8 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee6(taskType) {
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              _context6.next = 2;
              return callRemote({
                type: 'tasks/clearLog',
                payload: {
                  type: taskType
                }
              });

            case 2:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }));

    return function clearLog(_x8) {
      return _ref8.apply(this, arguments);
    };
  }();

  function unwrapExports(x) {
    return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
  }

  function createCommonjsModule(fn, module) {
    return module = {
      exports: {}
    }, fn(module, module.exports), module.exports;
  }

  var xtermAddonWebLinks = createCommonjsModule(function (module, exports) {
    !function (e, t) {
      module.exports = t();
    }(window, function () {
      return function (e) {
        var t = {};

        function n(o) {
          if (t[o]) return t[o].exports;
          var r = t[o] = {
            i: o,
            l: !1,
            exports: {}
          };
          return e[o].call(r.exports, r, r.exports, n), r.l = !0, r.exports;
        }

        return n.m = e, n.c = t, n.d = function (e, t, o) {
          n.o(e, t) || Object.defineProperty(e, t, {
            enumerable: !0,
            get: o
          });
        }, n.r = function (e) {
          "undefined" != typeof Symbol && Symbol.toStringTag && Object.defineProperty(e, Symbol.toStringTag, {
            value: "Module"
          }), Object.defineProperty(e, "__esModule", {
            value: !0
          });
        }, n.t = function (e, t) {
          if (1 & t && (e = n(e)), 8 & t) return e;
          if (4 & t && "object" == typeof e && e && e.__esModule) return e;
          var o = Object.create(null);
          if (n.r(o), Object.defineProperty(o, "default", {
            enumerable: !0,
            value: e
          }), 2 & t && "string" != typeof e) for (var r in e) n.d(o, r, function (t) {
            return e[t];
          }.bind(null, r));
          return o;
        }, n.n = function (e) {
          var t = e && e.__esModule ? function () {
            return e.default;
          } : function () {
            return e;
          };
          return n.d(t, "a", t), t;
        }, n.o = function (e, t) {
          return Object.prototype.hasOwnProperty.call(e, t);
        }, n.p = "", n(n.s = 0);
      }([function (e, t, n) {
        Object.defineProperty(t, "__esModule", {
          value: !0
        });
        var o = new RegExp("(?:^|[^\\da-z\\.-]+)((https?:\\/\\/)((([\\da-z\\.-]+)\\.([a-z\\.]{2,6}))|((\\d{1,3}\\.){3}\\d{1,3})|(localhost))(:\\d{1,5})?((\\/[\\/\\w\\.\\-%~:+]*)*([^:\"'\\s]))?(\\?[0-9\\w\\[\\]\\(\\)\\/\\?\\!#@$%&'*+,:;~\\=\\.\\-]*)?(#[0-9\\w\\[\\]\\(\\)\\/\\?\\!#@$%&'*+,:;~\\=\\.\\-]*)?)($|[^\\/\\w\\.\\-%]+)");

        function r(e, t) {
          window.open(t, "_blank");
        }

        var i = function () {
          function e(e, t) {
            void 0 === e && (e = r), void 0 === t && (t = {}), this._handler = e, this._options = t, this._options.matchIndex = 1;
          }

          return e.prototype.activate = function (e) {
            this._terminal = e, this._linkMatcherId = this._terminal.registerLinkMatcher(o, this._handler, this._options);
          }, e.prototype.dispose = function () {
            void 0 !== this._linkMatcherId && void 0 !== this._terminal && this._terminal.deregisterLinkMatcher(this._linkMatcherId);
          }, e;
        }();

        t.WebLinksAddon = i;
      }]);
    });
  });
  unwrapExports(xtermAddonWebLinks);
  var xtermAddonWebLinks_1 = xtermAddonWebLinks.WebLinksAddon;
  var _window = window,
      fit = _window.fit,
      webLinks = _window.webLinks,
      Terminal = _window.Terminal;

  function initTerminal() {
    Terminal.applyAddon(fit);
    var terminal = new Terminal({
      allowTransparency: true,
      theme: {
        background: '#15171C',
        foreground: '#ffffff73'
      },
      cursorBlink: false,
      cursorStyle: 'bar',
      disableStdin: true
    });
    terminal.loadAddon(new xtermAddonWebLinks_1());
    return terminal;
  }

  var TASKS = [TaskType.BUILD, TaskType.DEV, TaskType.LINT, TaskType.TEST, TaskType.INSTALL];
  var TERMINAL_MAPS = {};
  TASKS.forEach(function (taskType) {
    TERMINAL_MAPS[taskType] = initTerminal();
  });

  var getTerminalIns = function getTerminalIns(taskType) {
    return TERMINAL_MAPS[taskType];
  };

  var _TASK_TYPE_TEXT_MAP, _TASK_STATE_TEXT_MAP, _TaskType$BUILD, _TaskType$DEV, _TaskType$TEST, _TaskType$LINT, _TaskType$INSTALL, _NOTICE_MESSAGE_MAP;

  var TASK_TYPE_TEXT_MAP = (_TASK_TYPE_TEXT_MAP = {}, _defineProperty(_TASK_TYPE_TEXT_MAP, TaskType.BUILD, '构建'), _defineProperty(_TASK_TYPE_TEXT_MAP, TaskType.DEV, '本地开发'), _defineProperty(_TASK_TYPE_TEXT_MAP, TaskType.LINT, 'LINT'), _defineProperty(_TASK_TYPE_TEXT_MAP, TaskType.TEST, '测试'), _TASK_TYPE_TEXT_MAP);
  var TASK_STATE_TEXT_MAP = (_TASK_STATE_TEXT_MAP = {}, _defineProperty(_TASK_STATE_TEXT_MAP, TaskState.INIT, '初始化'), _defineProperty(_TASK_STATE_TEXT_MAP, TaskState.ING, '执行中'), _defineProperty(_TASK_STATE_TEXT_MAP, TaskState.SUCCESS, '执行成功'), _defineProperty(_TASK_STATE_TEXT_MAP, TaskState.FAIL, '执行失败'), _TASK_STATE_TEXT_MAP);

  var isCaredEvent = function isCaredEvent(taskType, caredTaskType) {
    if (!taskType || taskType !== caredTaskType) {
      return false;
    }

    return true;
  };

  var NOTICE_MESSAGE_MAP = (_NOTICE_MESSAGE_MAP = {}, _defineProperty(_NOTICE_MESSAGE_MAP, TaskType.BUILD, (_TaskType$BUILD = {}, _defineProperty(_TaskType$BUILD, TaskState.SUCCESS, {
    title: '构建成功',
    message: '成功'
  }), _defineProperty(_TaskType$BUILD, TaskState.FAIL, {
    title: '构建失败',
    message: '失败'
  }), _TaskType$BUILD)), _defineProperty(_NOTICE_MESSAGE_MAP, TaskType.DEV, (_TaskType$DEV = {}, _defineProperty(_TaskType$DEV, TaskState.SUCCESS, {
    title: '启动成功',
    message: '成功'
  }), _defineProperty(_TaskType$DEV, TaskState.FAIL, {
    title: '启动失败',
    message: '失败'
  }), _TaskType$DEV)), _defineProperty(_NOTICE_MESSAGE_MAP, TaskType.TEST, (_TaskType$TEST = {}, _defineProperty(_TaskType$TEST, TaskState.SUCCESS, {
    title: '测试成功',
    message: '成功'
  }), _defineProperty(_TaskType$TEST, TaskState.FAIL, {
    title: '测试失败',
    message: '失败'
  }), _TaskType$TEST)), _defineProperty(_NOTICE_MESSAGE_MAP, TaskType.LINT, (_TaskType$LINT = {}, _defineProperty(_TaskType$LINT, TaskState.SUCCESS, {
    title: '代码风格检查成功',
    message: '成功'
  }), _defineProperty(_TaskType$LINT, TaskState.FAIL, {
    title: '执行代码风格检查失败',
    message: '失败'
  }), _TaskType$LINT)), _defineProperty(_NOTICE_MESSAGE_MAP, TaskType.INSTALL, (_TaskType$INSTALL = {}, _defineProperty(_TaskType$INSTALL, TaskState.SUCCESS, {
    title: '安装依赖成功',
    message: '成功'
  }), _defineProperty(_TaskType$INSTALL, TaskState.FAIL, {
    title: '安装依赖失败',
    message: '失败'
  }), _TaskType$INSTALL)), _NOTICE_MESSAGE_MAP);

  function getNoticeMessage(taskType, state) {
    return _objectSpread2({
      type: state === TaskState.SUCCESS ? 'success' : 'error'
    }, NOTICE_MESSAGE_MAP[taskType][state]);
  }

  var callRemote;

  function initApiToGloal(api) {
    callRemote = api.callRemote; // eslint-disable-line
  }

  var useTaskDetail = function useTaskDetail(taskType) {
    var _useState = React.useState(true),
        _useState2 = _slicedToArray(_useState, 2),
        loading = _useState2[0],
        setLoading = _useState2[1];

    var _useState3 = React.useState({}),
        _useState4 = _slicedToArray(_useState3, 2),
        detail = _useState4[0],
        setDetail = _useState4[1];

    React.useEffect(function () {
      _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var _ref2, result;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                _context.next = 3;
                return getTaskDetail(taskType);

              case 3:
                _ref2 = _context.sent;
                result = _ref2.result;
                setLoading(false);
                setDetail(result);
                _context.next = 12;
                break;

              case 9:
                _context.prev = 9;
                _context.t0 = _context["catch"](0);
                setLoading(false);

              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[0, 9]]);
      }))();
    }, []);
    return {
      loading: loading,
      detail: detail
    };
  };

  var useTerminal = function useTerminal(_ref) {
    var terminal = _ref.terminal,
        container = _ref.ref;
    React.useEffect(function () {
      if (!container) {
        return;
      }

      terminal.open(container);
      terminal.fit();
    }, [container]);
  };

  var css$1 = ".index-module_wrapper__3T5Iw {\n  background-color: #15171c;\n  border-radius: 2px;\n  padding: 12px 16px;\n  font-size: 14px;\n  color: rgba(255, 255, 255, 0.65);\n  line-height: 22px;\n  height: 100%;\n}\n.index-module_titleWrapper__3VnWc {\n  margin-bottom: 8px;\n}\n.index-module_actionGroup__1OHJE {\n  text-align: right;\n}\n.index-module_actionGroup__1OHJE > i {\n  margin-left: 16px;\n}\n.index-module_logContainer__3TKyW {\n  padding: 0;\n  height: 100%;\n}\n";
  var styles$1 = {
    "wrapper": "index-module_wrapper__3T5Iw",
    "titleWrapper": "index-module_titleWrapper__3VnWc",
    "actionGroup": "index-module_actionGroup__1OHJE",
    "logContainer": "index-module_logContainer__3TKyW"
  };
  styleInject(css$1);

  var TerminalComponent = function TerminalComponent(_ref) {
    var terminal = _ref.terminal,
        log = _ref.log,
        onClear = _ref.onClear;
    var domContainer = React.useRef();

    var _useState = React.useState(false),
        _useState2 = _slicedToArray(_useState, 2),
        setInit = _useState2[1];

    React.useEffect(function () {
      setInit(true);
    }, []);
    useTerminal({
      terminal: terminal,
      ref: domContainer.current
    });
    React.useEffect(function () {
      if (log) {
        log.split('\n').forEach(function (msg) {
          terminal.writeln(msg);
        });
      }
    }, [log]);

    var clear = function clear() {
      terminal.clear();
      onClear && onClear();
    };

    var toBottom = function toBottom() {
      terminal.scrollToBottom();
    };

    return React__default.createElement("div", {
      className: styles$1.wrapper
    }, React__default.createElement(antd.Row, {
      className: styles$1.titleWrapper
    }, React__default.createElement(antd.Col, {
      span: 8,
      className: styles$1.formmatGroup
    }, "\u8F93\u51FA"), React__default.createElement(antd.Col, {
      span: 4,
      offset: 12,
      className: styles$1.actionGroup
    }, React__default.createElement(antd.Icon, {
      onClick: clear,
      type: "delete"
    }), React__default.createElement(antd.Icon, {
      onClick: toBottom,
      type: "enter"
    }))), React__default.createElement("div", {
      ref: domContainer,
      className: styles$1.logContainer
    }));
  };

  var taskType = TaskType.DEV;

  var DevComponent = function DevComponent(_ref) {
    var api = _ref.api;

    var _useState = React.useState({
      state: TaskState.INIT,
      type: taskType,
      log: ''
    }),
        _useState2 = _slicedToArray(_useState, 2),
        taskDetail = _useState2[0],
        setTaskDetail = _useState2[1];

    var _useState3 = React.useState(true),
        _useState4 = _slicedToArray(_useState3, 2),
        loading = _useState4[0],
        setLoading = _useState4[1];

    var _Form$useForm = antd.Form.useForm(),
        _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
        form = _Form$useForm2[0];

    var _useState5 = React.useState(false),
        _useState6 = _slicedToArray(_useState5, 2),
        modalVisible = _useState6[0],
        setModalVisible = _useState6[1];

    var _useState7 = React.useState({
      BABEL_POLYFILL: true,
      HMR: true,
      BABEL_CACHE: true,
      MOCK: true,
      BROWSER: true,
      CLEAR_CONSOLE: true,
      PORT: null,
      FORK_TS_CHECKER: false
    }),
        _useState8 = _slicedToArray(_useState7, 2),
        env = _useState8[0],
        setEnv = _useState8[1]; // Mount: 获取 task detail


    var _useTaskDetail = useTaskDetail(taskType),
        detailLoading = _useTaskDetail.loading,
        detail = _useTaskDetail.detail;

    React.useEffect(function () {
      setLoading(detailLoading);
      setTaskDetail(detail);
    }, [detail]); // Mount: 监听 task state 改变

    React.useEffect(function () {
      var unsubscribe = api.listenRemote({
        type: 'org.umi.task.state',
        onMessage: function onMessage(_ref2) {
          var result = _ref2.detail,
              type = _ref2.taskType;

          if (!isCaredEvent(type, taskType)) {
            return null;
          }

          if (result) {
            setTaskDetail(result);
          }
        }
      });
      return function () {
        unsubscribe && unsubscribe();
      };
    }, [detail]);

    function dev() {
      return _dev.apply(this, arguments);
    }

    function _dev() {
      _dev = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var _ref3, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return exec(taskType, env);

              case 2:
                _ref3 = _context.sent;
                triggerState = _ref3.triggerState;
                errMsg = _ref3.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    type: 'error',
                    title: '执行启动失败',
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return _dev.apply(this, arguments);
    }

    function cancelDev() {
      return _cancelDev.apply(this, arguments);
    }

    function _cancelDev() {
      _cancelDev = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var _ref4, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return cancel(taskType);

              case 2:
                _ref4 = _context2.sent;
                triggerState = _ref4.triggerState;
                errMsg = _ref4.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    title: '取消启动失败',
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));
      return _cancelDev.apply(this, arguments);
    }

    var openModal = function openModal() {
      setModalVisible(true);
    };

    var handleOk = function handleOk() {
      form.validateFields().then(function (values) {
        setEnv(values);
        setModalVisible(false);
      }).catch(function (_) {});
    };

    var handleCancel = function handleCancel() {
      setModalVisible(false);
    };

    var isTaskRunning = taskDetail && taskDetail.state === TaskState.ING;
    return React__default.createElement(React__default.Fragment, null, React__default.createElement("h1", {
      className: styles.title
    }, "\u672C\u5730\u542F\u52A8"), loading ? React__default.createElement(antd.Spin, null) : React__default.createElement(React__default.Fragment, null, React__default.createElement(antd.Row, null, React__default.createElement(antd.Col, {
      span: 8,
      className: styles.buttonGroup
    }, React__default.createElement(antd.Button, {
      type: "primary",
      onClick: isTaskRunning ? cancelDev : dev,
      loading: loading
    }, isTaskRunning ? '停止' : '启动'), React__default.createElement(antd.Button, {
      onClick: openModal
    }, "\u53D8\u91CF\u7BA1\u7406"), React__default.createElement(antd.Modal, {
      visible: modalVisible,
      title: "\u6784\u5EFA\u73AF\u5883\u53D8\u91CF",
      onOk: handleOk,
      onCancel: handleCancel
    }, React__default.createElement(antd.Form, {
      name: "devEnv",
      form: form,
      initialValues: env,
      layout: "vertical"
    }, React__default.createElement(antd.Form.Item, {
      label: "\u7AEF\u53E3\u53F7",
      name: "PORT"
    }, React__default.createElement(antd.Input, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u5F15\u5165 @babel/polyfill",
      name: "BABEL_POLYFILL",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u5F00\u542F\u70ED\u66F4\u65B0",
      name: "HMR",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u5F00\u542F babel cache",
      name: "BABEL_CACHE",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u5F00\u542F mock",
      name: "MOCK",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u542F\u52A8\u540E\u81EA\u52A8\u6253\u5F00\u6D4F\u89C8\u5668",
      name: "BROWSER",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u6E05\u5C4F",
      name: "CLEAR_CONSOLE",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u5F00\u542F TS \u68C0\u67E5",
      name: "FORK_TS_CHECKER",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)))))), React__default.createElement("div", {
      className: styles.logContainer
    }, React__default.createElement(TerminalComponent, {
      terminal: getTerminalIns(taskType),
      log: taskDetail.log,
      onClear: function onClear() {
        clearLog(taskType);
      }
    }))));
  };

  var taskType$1 = TaskType.BUILD;

  var BuildComponent = function BuildComponent(_ref) {
    var api = _ref.api;

    var _useState = React.useState({
      state: TaskState.INIT,
      type: taskType$1,
      log: ''
    }),
        _useState2 = _slicedToArray(_useState, 2),
        taskDetail = _useState2[0],
        setTaskDetail = _useState2[1];

    var _useState3 = React.useState(true),
        _useState4 = _slicedToArray(_useState3, 2),
        loading = _useState4[0],
        setLoading = _useState4[1];

    var _Form$useForm = antd.Form.useForm(),
        _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
        form = _Form$useForm2[0];

    var _useState5 = React.useState(false),
        _useState6 = _slicedToArray(_useState5, 2),
        modalVisible = _useState6[0],
        setModalVisible = _useState6[1];

    var _useState7 = React.useState({
      COMPRESS: true,
      CSS_COMPRESS: true,
      HTML: true,
      FORK_TS_CHECKER: false
    }),
        _useState8 = _slicedToArray(_useState7, 2),
        env = _useState8[0],
        setEnv = _useState8[1]; // Mount: 获取 task detail


    var _useTaskDetail = useTaskDetail(taskType$1),
        detailLoading = _useTaskDetail.loading,
        detail = _useTaskDetail.detail;

    React.useEffect(function () {
      setLoading(detailLoading);
      setTaskDetail(detail);
    }, [detail]); // Mount: 监听 task state 改变

    React.useEffect(function () {
      var unsubscribe = api.listenRemote({
        type: 'org.umi.task.state',
        onMessage: function onMessage(_ref2) {
          var result = _ref2.detail,
              type = _ref2.taskType;

          if (!isCaredEvent(type, taskType$1)) {
            return null;
          }

          if (result) {
            setTaskDetail(result);
          }
        }
      });
      return function () {
        unsubscribe && unsubscribe();
      };
    }, [detail]); // UnMount: reset form

    React.useEffect(function () {
      return function () {
        form.resetFields();
      };
    }, []);

    function build() {
      return _build.apply(this, arguments);
    }

    function _build() {
      _build = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var _ref3, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return exec(taskType$1, env);

              case 2:
                _ref3 = _context.sent;
                triggerState = _ref3.triggerState;
                errMsg = _ref3.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    type: 'error',
                    title: '执行构建失败',
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return _build.apply(this, arguments);
    }

    function cancelBuild() {
      return _cancelBuild.apply(this, arguments);
    }

    function _cancelBuild() {
      _cancelBuild = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var _ref4, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return cancel(taskType$1);

              case 2:
                _ref4 = _context2.sent;
                triggerState = _ref4.triggerState;
                errMsg = _ref4.errMsg;

                if (!(triggerState === TriggerState.FAIL)) {
                  _context2.next = 8;
                  break;
                }

                api.notify({
                  title: '取消构建失败',
                  message: errMsg
                });
                return _context2.abrupt("return");

              case 8:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));
      return _cancelBuild.apply(this, arguments);
    }

    var openModal = function openModal() {
      setModalVisible(true);
    };

    var handleOk = function handleOk() {
      form.validateFields().then(function (values) {
        setEnv(values);
        setModalVisible(false);
      }).catch(function (info) {
        setModalVisible(false);
      });
    };

    var handleCancel = function handleCancel() {
      setModalVisible(false);
    };

    var isTaskRunning = taskDetail && taskDetail.state === TaskState.ING;
    return React__default.createElement(React__default.Fragment, null, React__default.createElement("h1", {
      className: styles.title
    }, "\u6784\u5EFA"), loading ? React__default.createElement(antd.Spin, null) : React__default.createElement(React__default.Fragment, null, React__default.createElement(antd.Row, null, React__default.createElement(antd.Col, {
      span: 8,
      className: styles.buttonGroup
    }, React__default.createElement(antd.Button, {
      type: "primary",
      onClick: isTaskRunning ? cancelBuild : build,
      loading: loading
    }, isTaskRunning ? '停止' : '构建'), React__default.createElement(antd.Button, {
      onClick: openModal
    }, "\u53D8\u91CF\u7BA1\u7406"), React__default.createElement(antd.Modal, {
      visible: modalVisible,
      title: "\u6784\u5EFA\u73AF\u5883\u53D8\u91CF",
      onOk: handleOk,
      onCancel: handleCancel
    }, React__default.createElement(antd.Form, {
      name: "buildEnv",
      form: form,
      initialValues: env,
      layout: "vertical"
    }, React__default.createElement(antd.Form.Item, {
      label: "JS \u662F\u5426\u538B\u7F29",
      name: "COMPRESS",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "CSS \u662F\u5426\u538B\u7F29",
      name: "CSS_COMPRESS",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u5F15\u5165 @babel/polyfill",
      name: "BABEL_POLYFILL",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u5F00\u542F\u70ED\u66F4\u65B0",
      name: "HMR",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u5F00\u542F babel cache",
      name: "BABEL_CACHE",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u5F00\u542F mock",
      name: "MOCK",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u542F\u52A8\u540E\u81EA\u52A8\u6253\u5F00\u6D4F\u89C8\u5668",
      name: "BROWSER",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u6E05\u5C4F",
      name: "CLEAR_CONSOLE",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u6253\u5305 HTML \u6587\u4EF6",
      name: "HTML",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: "\u662F\u5426\u5F00\u542F TS \u68C0\u67E5",
      name: "FORK_TS_CHECKER",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)))))), React__default.createElement("div", {
      className: styles.logContainer
    }, React__default.createElement(TerminalComponent, {
      terminal: getTerminalIns(taskType$1),
      log: taskDetail.log
    }))));
  };

  var taskType$2 = TaskType.LINT;

  var LintComponent = function LintComponent(_ref) {
    var api = _ref.api;

    var _useState = React.useState({
      state: TaskState.INIT,
      type: taskType$2,
      log: ''
    }),
        _useState2 = _slicedToArray(_useState, 2),
        taskDetail = _useState2[0],
        setTaskDetail = _useState2[1];

    var _useState3 = React.useState(true),
        _useState4 = _slicedToArray(_useState3, 2),
        loading = _useState4[0],
        setLoading = _useState4[1]; // Mount: 获取 task detail


    var _useTaskDetail = useTaskDetail(taskType$2),
        detailLoading = _useTaskDetail.loading,
        detail = _useTaskDetail.detail;

    React.useEffect(function () {
      setLoading(detailLoading);
      setTaskDetail(detail);
    }, [detail]); // Mount: 监听 task state 改变

    React.useEffect(function () {
      var unsubscribe = api.listenRemote({
        type: 'org.umi.task.state',
        onMessage: function onMessage(_ref2) {
          var result = _ref2.detail,
              type = _ref2.taskType;

          if (!isCaredEvent(type, taskType$2)) {
            return null;
          }

          if (result) {
            setTaskDetail(result);
          }
        }
      });
      return function () {
        unsubscribe && unsubscribe();
      };
    }, [detail]);

    function lint() {
      return _lint.apply(this, arguments);
    }

    function _lint() {
      _lint = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var _ref3, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return exec(taskType$2);

              case 2:
                _ref3 = _context.sent;
                triggerState = _ref3.triggerState;
                errMsg = _ref3.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    type: 'error',
                    title: '执行代码风格检查失败',
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return _lint.apply(this, arguments);
    }

    function cancelLint() {
      return _cancelLint.apply(this, arguments);
    }

    function _cancelLint() {
      _cancelLint = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var _ref4, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return cancel(taskType$2);

              case 2:
                _ref4 = _context2.sent;
                triggerState = _ref4.triggerState;
                errMsg = _ref4.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    title: '取消代码风格检查失败',
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));
      return _cancelLint.apply(this, arguments);
    }

    var isTaskRunning = taskDetail && taskDetail.state === TaskState.ING;
    return React__default.createElement(React__default.Fragment, null, React__default.createElement("h1", {
      className: styles.title
    }, "\u4EE3\u7801\u98CE\u683C\u68C0\u67E5"), loading ? React__default.createElement(antd.Spin, null) : React__default.createElement(React__default.Fragment, null, React__default.createElement(antd.Row, null, React__default.createElement(antd.Col, {
      span: 8,
      className: styles.buttonGroup
    }, React__default.createElement(antd.Button, {
      type: "primary",
      onClick: isTaskRunning ? cancelLint : lint,
      loading: loading
    }, isTaskRunning ? '停止' : '执行'))), React__default.createElement("div", {
      className: styles.logContainer
    }, React__default.createElement(TerminalComponent, {
      terminal: getTerminalIns(taskType$2),
      log: taskDetail.log
    }))));
  };

  var taskType$3 = TaskType.TEST;

  var TestComponent = function TestComponent(_ref) {
    var api = _ref.api;

    var _useState = React.useState({
      state: TaskState.INIT,
      type: taskType$3,
      log: ''
    }),
        _useState2 = _slicedToArray(_useState, 2),
        taskDetail = _useState2[0],
        setTaskDetail = _useState2[1];

    var _useState3 = React.useState(true),
        _useState4 = _slicedToArray(_useState3, 2),
        loading = _useState4[0],
        setLoading = _useState4[1]; // Mount: 获取 task detail


    var _useTaskDetail = useTaskDetail(taskType$3),
        detailLoading = _useTaskDetail.loading,
        detail = _useTaskDetail.detail;

    React.useEffect(function () {
      setLoading(detailLoading);
      setTaskDetail(detail);
    }, [detail]); // Mount: 监听 task state 改变

    React.useEffect(function () {
      var unsubscribe = api.listenRemote({
        type: 'org.umi.task.state',
        onMessage: function onMessage(_ref2) {
          var result = _ref2.detail,
              type = _ref2.taskType;

          if (!isCaredEvent(type, taskType$3)) {
            return null;
          }

          if (result) {
            setTaskDetail(result);
          }
        }
      });
      return function () {
        unsubscribe && unsubscribe();
      };
    }, [detail]);

    function test() {
      return _test.apply(this, arguments);
    }

    function _test() {
      _test = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var _ref3, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return exec(taskType$3);

              case 2:
                _ref3 = _context.sent;
                triggerState = _ref3.triggerState;
                errMsg = _ref3.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    type: 'error',
                    title: '执行测试失败',
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return _test.apply(this, arguments);
    }

    function cancelTest() {
      return _cancelTest.apply(this, arguments);
    }

    function _cancelTest() {
      _cancelTest = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var _ref4, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return cancel(taskType$3);

              case 2:
                _ref4 = _context2.sent;
                triggerState = _ref4.triggerState;
                errMsg = _ref4.errMsg;

                if (!(triggerState === TriggerState.FAIL)) {
                  _context2.next = 8;
                  break;
                }

                api.notify({
                  title: '取消测试失败',
                  message: errMsg
                });
                return _context2.abrupt("return");

              case 8:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));
      return _cancelTest.apply(this, arguments);
    }

    var isTaskRunning = taskDetail && taskDetail.state === TaskState.ING;
    return React__default.createElement(React__default.Fragment, null, React__default.createElement("h1", {
      className: styles.title
    }, "\u6D4B\u8BD5"), loading ? React__default.createElement(antd.Spin, null) : React__default.createElement(React__default.Fragment, null, React__default.createElement(antd.Row, null, React__default.createElement(antd.Col, {
      span: 8,
      className: styles.buttonGroup
    }, React__default.createElement(antd.Button, {
      type: "primary",
      onClick: isTaskRunning ? cancelTest : test,
      loading: loading
    }, isTaskRunning ? '停止' : '测试'))), React__default.createElement("div", {
      className: styles.logContainer
    }, React__default.createElement(TerminalComponent, {
      terminal: getTerminalIns(taskType$3),
      log: taskDetail.log
    }))));
  };

  var taskType$4 = TaskType.INSTALL;

  var InstallComponent = function InstallComponent(_ref) {
    var api = _ref.api;

    var _useState = React.useState({
      state: TaskState.INIT,
      type: taskType$4,
      log: ''
    }),
        _useState2 = _slicedToArray(_useState, 2),
        taskDetail = _useState2[0],
        setTaskDetail = _useState2[1];

    var _useState3 = React.useState(true),
        _useState4 = _slicedToArray(_useState3, 2),
        loading = _useState4[0],
        setLoading = _useState4[1]; // Mount: 获取 task detail


    var _useTaskDetail = useTaskDetail(taskType$4),
        detailLoading = _useTaskDetail.loading,
        detail = _useTaskDetail.detail;

    React.useEffect(function () {
      setLoading(detailLoading);
      setTaskDetail(detail);
    }, [detail]); // Mount: 监听 task state 改变

    React.useEffect(function () {
      var unsubscribe = api.listenRemote({
        type: 'org.umi.task.state',
        onMessage: function onMessage(_ref2) {
          var result = _ref2.detail,
              type = _ref2.taskType;

          if (!isCaredEvent(type, taskType$4)) {
            return null;
          }

          if (result) {
            setTaskDetail(result);
          }
        }
      });
      return function () {
        unsubscribe && unsubscribe();
      };
    }, [detail]);

    function install() {
      return _install.apply(this, arguments);
    }

    function _install() {
      _install = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var _ref3, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return exec(taskType$4);

              case 2:
                _ref3 = _context.sent;
                triggerState = _ref3.triggerState;
                errMsg = _ref3.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    type: 'error',
                    title: '执行安装依赖失败',
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return _install.apply(this, arguments);
    }

    function cancelInstall() {
      return _cancelInstall.apply(this, arguments);
    }

    function _cancelInstall() {
      _cancelInstall = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var _ref4, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return cancel(taskType$4);

              case 2:
                _ref4 = _context2.sent;
                triggerState = _ref4.triggerState;
                errMsg = _ref4.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    title: '取消安装依赖失败',
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));
      return _cancelInstall.apply(this, arguments);
    }

    var isTaskRunning = taskDetail && taskDetail.state === TaskState.ING;
    return React__default.createElement(React__default.Fragment, null, React__default.createElement("h1", {
      className: styles.title
    }, "\u91CD\u88C5\u4F9D\u8D56"), loading ? React__default.createElement(antd.Spin, null) : React__default.createElement(React__default.Fragment, null, React__default.createElement(antd.Row, null, React__default.createElement(antd.Col, {
      span: 8,
      className: styles.buttonGroup
    }, React__default.createElement(antd.Button, {
      type: "primary",
      onClick: isTaskRunning ? cancelInstall : install,
      loading: loading
    }, isTaskRunning ? '停止' : '执行'))), React__default.createElement("div", {
      className: styles.logContainer
    }, React__default.createElement(TerminalComponent, {
      terminal: getTerminalIns(taskType$4),
      log: taskDetail.log
    }))));
  };

  var ui = function ui(api) {
    var _SCRIPTS;

    initApiToGloal(api);
    var TwoColumnPanel = api.TwoColumnPanel,
        callRemote = api.callRemote;
    var SCRIPTS = (_SCRIPTS = {}, _defineProperty(_SCRIPTS, TaskType.DEV, {
      title: '本地开发',
      icon: React__default.createElement("img", {
        width: "32",
        height: "32",
        src: "https://gw.alipayobjects.com/zos/basement_prod/14f00c22-7720-41c9-82cc-acf9c47c2c56.svg"
      }),
      description: '启动本地服务器',
      Component: DevComponent
    }), _defineProperty(_SCRIPTS, TaskType.BUILD, {
      title: '构建',
      icon: React__default.createElement("img", {
        width: "32",
        height: "32",
        src: "https://gw.alipayobjects.com/zos/basement_prod/14f00c22-7720-41c9-82cc-acf9c47c2c56.svg"
      }),
      description: '项目构建',
      Component: BuildComponent
    }), _defineProperty(_SCRIPTS, TaskType.LINT, {
      title: '代码风格检查',
      icon: React__default.createElement("img", {
        width: "32",
        height: "32",
        src: "https://gw.alipayobjects.com/zos/basement_prod/45bdf48e-3063-4a81-b2c3-49bfe67141c1.svg"
      }),
      description: '代码风格校验',
      Component: LintComponent
    }), _defineProperty(_SCRIPTS, TaskType.TEST, {
      title: '测试',
      icon: React__default.createElement("img", {
        width: "32",
        height: "32",
        src: "https://gw.alipayobjects.com/zos/basement_prod/bc817f9d-5b67-4b04-b568-3f6fe8792e90.svg"
      }),
      description: '项目测试',
      Component: TestComponent
    }), _defineProperty(_SCRIPTS, TaskType.INSTALL, {
      title: '重装依赖',
      icon: React__default.createElement("img", {
        width: "32",
        height: "32",
        src: "https://gw.alipayobjects.com/mdn/rms_38b4e4/afts/img/A*o7rAS63dOUEAAAAAAAAAAABkARQnAQ"
      }),
      description: '重新安装依赖',
      Component: InstallComponent
    }), _SCRIPTS); // 插件初始化

    callRemote({
      type: 'plugin/init'
    });
    api.listenRemote({
      type: 'org.umi.task.log',
      onMessage: function onMessage(_ref) {
        var _ref$data = _ref.data,
            data = _ref$data === void 0 ? '' : _ref$data,
            taskType = _ref.taskType;

        if (!data) {
          return;
        }

        var terminal = getTerminalIns(taskType);
        data.split('\n').forEach(function (msg) {
          if (!msg) {
            return;
          }

          terminal.writeln(msg);
        });
      }
    }); // 全局通知

    api.listenRemote({
      type: 'org.umi.task.state',
      onMessage: function onMessage(_ref2) {
        var result = _ref2.detail,
            type = _ref2.taskType;
        var state = result.state;

        if ([TaskState.INIT, TaskState.ING].indexOf(state) > -1) {
          return;
        }

        api.notify(getNoticeMessage(type, state));
      }
    });

    var TasksView = function TasksView() {
      return React__default.createElement(TwoColumnPanel, {
        sections: Object.keys(SCRIPTS).map(function (taskType) {
          var _SCRIPTS$taskType = SCRIPTS[taskType],
              title = _SCRIPTS$taskType.title,
              icon = _SCRIPTS$taskType.icon,
              description = _SCRIPTS$taskType.description,
              Component = _SCRIPTS$taskType.Component;
          return {
            title: title,
            icon: icon,
            description: description,
            component: function component() {
              return React__default.createElement(Component, {
                api: api
              });
            }
          };
        })
      });
    };

    api.addPanel({
      title: '任务管理',
      path: '/tasks',
      icon: {
        type: 'project',
        theme: 'filled'
      },
      component: TasksView
    });
  };

  return ui;
});