"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

var _Tasks = require("./Tasks");

var _enums = require("./enums");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

class TaskManager {
  constructor(api) {
    this.api = void 0;
    this.tasks = void 0;
    this.api = api;
    const opts = {
      api
    };
    this.tasks = {
      [_enums.TaskType.BUILD]: new _Tasks.BuildTask(opts),
      [_enums.TaskType.DEV]: new _Tasks.DevTask(opts),
      [_enums.TaskType.LINT]: new _Tasks.LintTask(opts),
      [_enums.TaskType.TEST]: new _Tasks.TestTask(opts),
      [_enums.TaskType.INSTALL]: new _Tasks.InstallTask(opts)
    };
  }

  getAllTasks() {
    return Object.keys(this.tasks).map(type => ({
      type,
      task: this.tasks[type]
    }));
  }

  getTask(type) {
    return this.tasks[type];
  }
  /**
   * 获取全部 task 的状态
   */


  getTasksState() {
    var _this = this;

    return _asyncToGenerator(function* () {
      return Object.keys(_this.tasks).map(type => {
        const task = _this.tasks[type];
        return {
          type: task.type,
          state: task.state
        };
      });
    })();
  }

  getTaskDetail(type) {
    const task = this.tasks[type];
    return {
      type: task.type,
      state: task.state
    };
  }

}

var _default = TaskManager;
exports.default = _default;