"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseTask = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _path() {
  const data = require("path");

  _path = function _path() {
    return data;
  };

  return data;
}

function _events() {
  const data = require("events");

  _events = function _events() {
    return data;
  };

  return data;
}

var _enums = require("../enums");

var _util = require("../../util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

class BaseTask extends _events().EventEmitter {
  constructor({
    api
  }) {
    super();
    this.state = _enums.TaskState.INIT;
    this.proc = void 0;
    this.type = void 0;
    this.api = void 0;
    this.pkgPath = void 0;
    this.isBigfishProject = void 0;
    this.api = api;
    this.pkgPath = (0, _path().join)(api.cwd, 'package.json');
    this.isBigfishProject = !!process.env.BIGFISH_COMPAT;
  }

  run(_ = {}) {
    var _this = this;

    return _asyncToGenerator(function* () {
      _this.state = _enums.TaskState.ING;

      _this.emit(_enums.TaskEventType.STATE_EVENT, _this.state);
    })();
  }

  cancel() {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      const proc = _this2.proc;

      if (!proc) {
        return;
      } // 子任务执行结束


      if ([_enums.TaskState.FAIL, _enums.TaskState.SUCCESS].indexOf(_this2.state) > -1) {
        return;
      }

      _this2.state = _enums.TaskState.INIT; // 杀掉子进程

      proc.kill('SIGTERM');
    })();
  }

  runCommand(script, opts) {
    var _this3 = this;

    return _asyncToGenerator(function* () {
      if (!script) {
        (0, _util.error)('script can not be empty');
      }

      _this3.proc = (0, _util.runCommand)(script, opts);
      const proc = _this3.proc;
      proc.stdout.on('data', buf => {
        _this3.emit(_enums.TaskEventType.STD_OUT_DATA, buf.toString());
      });
      proc.stderr.on('data', buf => {
        _this3.emit(_enums.TaskEventType.STD_ERR_DATA, buf.toString());
      });
      proc.on('error', () => {
        _this3.state = _enums.TaskState.FAIL;
      });

      const exitHandler = (code, signal) => {
        if (signal === 'SIGTERM') {
          // 用户取消任务
          _this3.state = _enums.TaskState.INIT;
        } else {
          // 自然退出
          _this3.state = code !== 0 ? _enums.TaskState.FAIL : _enums.TaskState.SUCCESS;
        } // 触发事件


        _this3.emit(_enums.TaskEventType.STATE_EVENT, _this3.state);
      };

      proc.on('close', exitHandler);
      proc.on('exit', exitHandler);
    })();
  }

}

exports.BaseTask = BaseTask;