"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Dev = _interopRequireDefault(require("./ui/components/Dev"));

var _Build = _interopRequireDefault(require("./ui/components/Build"));

var _Lint = _interopRequireDefault(require("./ui/components/Lint"));

var _Test = _interopRequireDefault(require("./ui/components/Test"));

var _Install = _interopRequireDefault(require("./ui/components/Install"));

var _util = require("./ui/util");

var _enums = require("./server/core/enums");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = function _default(api) {
  var _SCRIPTS;

  (0, _util.initApiToGloal)(api);
  var TwoColumnPanel = api.TwoColumnPanel,
      callRemote = api.callRemote;
  var SCRIPTS = (_SCRIPTS = {}, _defineProperty(_SCRIPTS, _enums.TaskType.DEV, {
    title: '本地开发',
    icon: _react.default.createElement("img", {
      width: "32",
      height: "32",
      src: "https://gw.alipayobjects.com/zos/basement_prod/14f00c22-7720-41c9-82cc-acf9c47c2c56.svg"
    }),
    description: '启动本地服务器',
    Component: _Dev.default
  }), _defineProperty(_SCRIPTS, _enums.TaskType.BUILD, {
    title: '构建',
    icon: _react.default.createElement("img", {
      width: "32",
      height: "32",
      src: "https://gw.alipayobjects.com/zos/basement_prod/14f00c22-7720-41c9-82cc-acf9c47c2c56.svg"
    }),
    description: '项目构建',
    Component: _Build.default
  }), _defineProperty(_SCRIPTS, _enums.TaskType.LINT, {
    title: '代码风格检查',
    icon: _react.default.createElement("img", {
      width: "32",
      height: "32",
      src: "https://gw.alipayobjects.com/zos/basement_prod/45bdf48e-3063-4a81-b2c3-49bfe67141c1.svg"
    }),
    description: '代码风格校验',
    Component: _Lint.default
  }), _defineProperty(_SCRIPTS, _enums.TaskType.TEST, {
    title: '测试',
    icon: _react.default.createElement("img", {
      width: "32",
      height: "32",
      src: "https://gw.alipayobjects.com/zos/basement_prod/bc817f9d-5b67-4b04-b568-3f6fe8792e90.svg"
    }),
    description: '项目测试',
    Component: _Test.default
  }), _defineProperty(_SCRIPTS, _enums.TaskType.INSTALL, {
    title: '重装依赖',
    icon: _react.default.createElement("img", {
      width: "32",
      height: "32",
      src: "https://gw.alipayobjects.com/mdn/rms_38b4e4/afts/img/A*o7rAS63dOUEAAAAAAAAAAABkARQnAQ"
    }),
    description: '重新安装依赖',
    Component: _Install.default
  }), _SCRIPTS); // 插件初始化

  callRemote({
    type: 'plugin/init'
  });
  api.listenRemote({
    type: 'org.umi.task.log',
    onMessage: function onMessage(_ref) {
      var _ref$data = _ref.data,
          data = _ref$data === void 0 ? '' : _ref$data,
          taskType = _ref.taskType;

      if (!data) {
        return;
      }

      var terminal = (0, _util.getTerminalIns)(taskType);
      data.split('\n').forEach(function (msg) {
        if (!msg) {
          return;
        }

        terminal.writeln(msg);
      });
    }
  }); // 全局通知

  api.listenRemote({
    type: 'org.umi.task.state',
    onMessage: function onMessage(_ref2) {
      var result = _ref2.detail,
          type = _ref2.taskType;
      var state = result.state;

      if ([_enums.TaskState.INIT, _enums.TaskState.ING].indexOf(state) > -1) {
        return;
      }

      api.notify((0, _util.getNoticeMessage)(type, state));
    }
  });

  var TasksView = function TasksView() {
    return _react.default.createElement(TwoColumnPanel, {
      sections: Object.keys(SCRIPTS).map(function (taskType) {
        var _SCRIPTS$taskType = SCRIPTS[taskType],
            title = _SCRIPTS$taskType.title,
            icon = _SCRIPTS$taskType.icon,
            description = _SCRIPTS$taskType.description,
            Component = _SCRIPTS$taskType.Component;
        return {
          title: title,
          icon: icon,
          description: description,
          component: function component() {
            return _react.default.createElement(Component, {
              api: api
            });
          }
        };
      })
    });
  };

  api.addPanel({
    title: '任务管理',
    path: '/tasks',
    icon: {
      type: 'project',
      theme: 'filled'
    },
    component: TasksView
  });
};

exports.default = _default;