"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _uiModule = _interopRequireDefault(require("../../ui.module.less"));

var _enums = require("../../../server/core/enums");

var _util = require("../../util");

var _hooks = require("../../hooks");

var _Terminal = _interopRequireDefault(require("../Terminal"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var taskType = _enums.TaskType.DEV;

var DevComponent = function DevComponent(_ref) {
  var api = _ref.api;

  var _useState = (0, _react.useState)({
    state: _enums.TaskState.INIT,
    type: taskType,
    log: ''
  }),
      _useState2 = _slicedToArray(_useState, 2),
      taskDetail = _useState2[0],
      setTaskDetail = _useState2[1];

  var _useState3 = (0, _react.useState)(true),
      _useState4 = _slicedToArray(_useState3, 2),
      loading = _useState4[0],
      setLoading = _useState4[1];

  var _Form$useForm = _antd.Form.useForm(),
      _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
      form = _Form$useForm2[0];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      modalVisible = _useState6[0],
      setModalVisible = _useState6[1];

  var _useState7 = (0, _react.useState)({
    BABEL_POLYFILL: true,
    HMR: true,
    BABEL_CACHE: true,
    MOCK: true,
    BROWSER: true,
    CLEAR_CONSOLE: true,
    PORT: null,
    FORK_TS_CHECKER: false
  }),
      _useState8 = _slicedToArray(_useState7, 2),
      env = _useState8[0],
      setEnv = _useState8[1]; // Mount: 获取 task detail


  var _useTaskDetail = (0, _hooks.useTaskDetail)(taskType),
      detailLoading = _useTaskDetail.loading,
      detail = _useTaskDetail.detail;

  (0, _react.useEffect)(function () {
    setLoading(detailLoading);
    setTaskDetail(detail);
  }, [detail]); // Mount: 监听 task state 改变

  (0, _react.useEffect)(function () {
    var unsubscribe = api.listenRemote({
      type: 'org.umi.task.state',
      onMessage: function onMessage(_ref2) {
        var result = _ref2.detail,
            type = _ref2.taskType;

        if (!(0, _util.isCaredEvent)(type, taskType)) {
          return null;
        }

        if (result) {
          setTaskDetail(result);
        }
      }
    });
    return function () {
      unsubscribe && unsubscribe();
    };
  }, [detail]);

  function dev() {
    return _dev.apply(this, arguments);
  }

  function _dev() {
    _dev = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      var _ref3, triggerState, errMsg;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _util.exec)(taskType, env);

            case 2:
              _ref3 = _context.sent;
              triggerState = _ref3.triggerState;
              errMsg = _ref3.errMsg;

              if (triggerState === _util.TriggerState.FAIL) {
                api.notify({
                  type: 'error',
                  title: '执行启动失败',
                  message: errMsg
                });
              }

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _dev.apply(this, arguments);
  }

  function cancelDev() {
    return _cancelDev.apply(this, arguments);
  }

  function _cancelDev() {
    _cancelDev = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2() {
      var _ref4, triggerState, errMsg;

      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return (0, _util.cancel)(taskType);

            case 2:
              _ref4 = _context2.sent;
              triggerState = _ref4.triggerState;
              errMsg = _ref4.errMsg;

              if (triggerState === _util.TriggerState.FAIL) {
                api.notify({
                  title: '取消启动失败',
                  message: errMsg
                });
              }

            case 6:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return _cancelDev.apply(this, arguments);
  }

  var openModal = function openModal() {
    setModalVisible(true);
  };

  var handleOk = function handleOk() {
    form.validateFields().then(function (values) {
      setEnv(values);
      setModalVisible(false);
    }).catch(function (_) {});
  };

  var handleCancel = function handleCancel() {
    setModalVisible(false);
  };

  var isTaskRunning = taskDetail && taskDetail.state === _enums.TaskState.ING;
  return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement("h1", {
    className: _uiModule.default.title
  }, "\u672C\u5730\u542F\u52A8"), loading ? _react.default.createElement(_antd.Spin, null) : _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_antd.Row, null, _react.default.createElement(_antd.Col, {
    span: 8,
    className: _uiModule.default.buttonGroup
  }, _react.default.createElement(_antd.Button, {
    type: "primary",
    onClick: isTaskRunning ? cancelDev : dev,
    loading: loading
  }, isTaskRunning ? '停止' : '启动'), _react.default.createElement(_antd.Button, {
    onClick: openModal
  }, "\u53D8\u91CF\u7BA1\u7406"), _react.default.createElement(_antd.Modal, {
    visible: modalVisible,
    title: "\u6784\u5EFA\u73AF\u5883\u53D8\u91CF",
    onOk: handleOk,
    onCancel: handleCancel
  }, _react.default.createElement(_antd.Form, {
    name: "devEnv",
    form: form,
    initialValues: env,
    layout: "vertical"
  }, _react.default.createElement(_antd.Form.Item, {
    label: "\u7AEF\u53E3\u53F7",
    name: "PORT"
  }, _react.default.createElement(_antd.Input, null)), _react.default.createElement(_antd.Form.Item, {
    label: "\u662F\u5426\u5F15\u5165 @babel/polyfill",
    name: "BABEL_POLYFILL",
    valuePropName: "checked"
  }, _react.default.createElement(_antd.Switch, null)), _react.default.createElement(_antd.Form.Item, {
    label: "\u662F\u5426\u5F00\u542F\u70ED\u66F4\u65B0",
    name: "HMR",
    valuePropName: "checked"
  }, _react.default.createElement(_antd.Switch, null)), _react.default.createElement(_antd.Form.Item, {
    label: "\u662F\u5426\u5F00\u542F babel cache",
    name: "BABEL_CACHE",
    valuePropName: "checked"
  }, _react.default.createElement(_antd.Switch, null)), _react.default.createElement(_antd.Form.Item, {
    label: "\u662F\u5426\u5F00\u542F mock",
    name: "MOCK",
    valuePropName: "checked"
  }, _react.default.createElement(_antd.Switch, null)), _react.default.createElement(_antd.Form.Item, {
    label: "\u662F\u5426\u542F\u52A8\u540E\u81EA\u52A8\u6253\u5F00\u6D4F\u89C8\u5668",
    name: "BROWSER",
    valuePropName: "checked"
  }, _react.default.createElement(_antd.Switch, null)), _react.default.createElement(_antd.Form.Item, {
    label: "\u662F\u5426\u6E05\u5C4F",
    name: "CLEAR_CONSOLE",
    valuePropName: "checked"
  }, _react.default.createElement(_antd.Switch, null)), _react.default.createElement(_antd.Form.Item, {
    label: "\u662F\u5426\u5F00\u542F TS \u68C0\u67E5",
    name: "FORK_TS_CHECKER",
    valuePropName: "checked"
  }, _react.default.createElement(_antd.Switch, null)))))), _react.default.createElement("div", {
    className: _uiModule.default.logContainer
  }, _react.default.createElement(_Terminal.default, {
    terminal: (0, _util.getTerminalIns)(taskType),
    log: taskDetail.log,
    onClear: function onClear() {
      (0, _util.clearLog)(taskType);
    }
  }))));
};

var _default = DevComponent;
exports.default = _default;